import store from '@/store'
import config from '@/config'
import errorCode from '@/utils/errorCode'
import {
	toast,
	showConfirm,
	tansParams
} from '@/utils/common'

let timeout = 60 * 2 * 1000

const token = 'token 5793f8d09ea4b5cea097e3ed3704493009b52147';
const baseUrl = `${ config.giteaUrl }/api/v1/repos/Wance/rd_mes_uniapp`;

const request = config => {
	config.header = config.header || {}
	config.header['Authorization'] = token

	// get请求映射params参数
	if (config.params) {
		let url = config.url + '?' + tansParams(config.params)
		url = url.slice(0, -1)
		config.url = url
	}

	return new Promise((resolve, reject) => {
		uni.request({
				method: config.method || 'get',
				timeout: config.timeout || timeout,
				url: baseUrl + config.url,
				data: config.data,
				header: config.header,
				dataType: 'json'
			}).then(response => {
				let [error, res] = response
				if (error) {
					toast('后端接口连接异常')
					reject('后端接口连接异常')
					return
				}
				console.log(res)
				const code = res.statusCode || 200
				const msg = res.errMsg || errorCode[code]

				switch (code) {
					case 200:
						resolve(res.data);
						break;
					case 401:
						showConfirm('登录状态已过期，您可以继续留在该页面，或者重新登录?').then(res => {
							if (res.confirm) {
								store.dispatch('LogOut').then(() => {
									uni.reLaunch({
										url: '/pages/login'
									})
								})
							}
						})
						reject('无效的会话，或者会话已过期，请重新登录')
						break;
					case 500:
						toast(msg);
						reject({
							code: 500,
							msg
						})
						break;
					default:
						toast(msg);
						reject(code);
						break;
				}
			})
		.catch(error => {
			let {
				message
			} = error
			if (message === 'Network Error') {
				message = '后端接口连接异常'
			} else if (message.includes('timeout')) {
				message = '系统接口请求超时'
			} else if (message.includes('Request failed with status code')) {
				message = '系统接口' + message.substr(message.length - 3) + '异常'
			}
			toast(message)
			reject(error)
		})
	})
}

export default request;